function slowal_frames2selecional_preferencies(unified_frame, slowal_frames) {
  const unified_argument_2_selecional_preferencies = {}
  for (let i in unified_frame.slowal_frame_mapping) {
    const slowal_frame_mapping = unified_frame.slowal_frame_mapping[i];
    let slowal_frame = slowal_frames.find(o => o.id === slowal_frame_mapping.slowal_frame_id);
    if(slowal_frame != null) {
      for (let j in slowal_frame_mapping.slowal_frame_argument_mapping) {
        const slowal_frame_argument_mapping = slowal_frame_mapping.slowal_frame_argument_mapping[j];

        let slowal_frame_argument = slowal_frame.arguments.find(o => o.argument_id === slowal_frame_argument_mapping.slowal_frame_agrument_id);
        let unified_frame_argument = unified_frame.arguments.find(o => o.id === slowal_frame_argument_mapping.unified_frame_agrument_id);

        let preferenceEntry = unified_argument_2_selecional_preferencies[slowal_frame_argument_mapping.unified_frame_agrument_id];
        if (preferenceEntry == null) {
          preferenceEntry = [];
          unified_argument_2_selecional_preferencies[slowal_frame_argument_mapping.unified_frame_agrument_id] = preferenceEntry
        }

        const unified_frame_argument_preferences = new Set(preferenceEntry.map(preference => preference.str));

        preferenceEntry.push.apply(preferenceEntry, slowal_frame_argument.preferences.filter(preference => !unified_frame_argument_preferences.has(preference.str)))
      }
    }
  }

  for (const [key, value] of Object.entries(unified_argument_2_selecional_preferencies)) {
    value.sort((a,b) => -a.type.localeCompare(b.type));
  }

  return unified_argument_2_selecional_preferencies;
}

const DEFAUTL_TIMEOUT = 60000;

function send_post_request(path, data, succ_func, err_func) {
  send_post_request_with_timeout(path, data, succ_func, err_func, DEFAUTL_TIMEOUT);
}

function send_post_request_with_timeout(path, data, succ_func, err_func, timeout) {
  $("#overlay").fadeIn(300);
  $.ajax({
    type: 'post',
    url: '/' + lang + path,
    dataType: 'json',
    data: data,
    timeout: timeout,
    success: function (response) {
      $("#overlay").fadeOut(300);
      succ_func(response);
    }.bind(this),
    error: function (request, errorType, errorMessage) {
      $("#overlay").fadeOut(300);
      err_func(request, errorType, errorMessage);
    }
  });
}

export {
  slowal_frames2selecional_preferencies,
  send_post_request,
  send_post_request_with_timeout
};
